function varargout = Phasor_diagram_analyser(varargin)
% PHASOR_DIAGRAM_ANALYSER MATLAB code for Phasor_diagram_analyser.fig
%      PHASOR_DIAGRAM_ANALYSER, by itself, creates a new PHASOR_DIAGRAM_ANALYSER or raises the existing
%      singleton*.
%
%      H = PHASOR_DIAGRAM_ANALYSER returns the handle to a new PHASOR_DIAGRAM_ANALYSER or the handle to
%      the existing singleton*.
%
%      PHASOR_DIAGRAM_ANALYSER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in PHASOR_DIAGRAM_ANALYSER.M with the given input arguments.
%
%      PHASOR_DIAGRAM_ANALYSER('Property','Value',...) creates a new PHASOR_DIAGRAM_ANALYSER or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Phasor_diagram_analyser_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Phasor_diagram_analyser_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Phasor_diagram_analyser

% Last Modified by GUIDE v2.5 15-May-2014 17:43:39

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Phasor_diagram_analyser_OpeningFcn, ...
                   'gui_OutputFcn',  @Phasor_diagram_analyser_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before Phasor_diagram_analyser is made visible.
function Phasor_diagram_analyser_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Phasor_diagram_analyser (see VARARGIN)

% Choose default command line output for Phasor_diagram_analyser
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes Phasor_diagram_analyser wait for user response (see UIRESUME)
% uiwait(handles.figure1);

fazory(handles)

% --- Outputs from this function are returned to the command line.
function varargout = Phasor_diagram_analyser_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function fazory(handles)
clear ii
% prepinanie medzi zobrazenim prudov a napati
if (get(handles.radiobutton_U,'Value')==1)      % in case of Voltage measuremt
    ut1 = evalin('base', 'ut_U.time');          % define values from workspace
    Um1 = evalin('base', 'Um.signals.values');
    omegatL1 = evalin('base', 'omegat_U.signals(1,1).values');
    omegatL2 = evalin('base', 'omegat_U.signals(1,2).values');
    omegatL3 = evalin('base', 'omegat_U.signals(1,3).values');
    utL = evalin('base', 'ut_U.signals.values');
    set(handles.text_L1,'String','UL1 (V)')         % set names of checkboxes in GUI in case of Voltage panel
    set(handles.text_L2,'String','UL2 (V)')
    set(handles.text_L3,'String','UL3 (V)')
    set(handles.uipanel3,'Title','Voltage panel')
    set(handles.popupmenu1, 'Visible','On');
    ylabel('Voltage [V]');
else                                            % in case of Current measuremt
    ut1 = evalin('base', 'ut_I.time');          % define values from workspace
    Um1 = evalin('base', 'Im.signals.values');
    omegatL1 = evalin('base', 'omegat_I.signals(1,1).values');
    omegatL2 = evalin('base', 'omegat_I.signals(1,2).values');
    omegatL3 = evalin('base', 'omegat_I.signals(1,3).values');
    utL = evalin('base', 'ut_I.signals.values');
    set(handles.text_L1,'String','IL1 (A)')         % set names of checkboxes in GUI in case of Current panel
    set(handles.text_L2,'String','IL2 (A)')
    set(handles.text_L3,'String','IL3 (A)')
    set(handles.uipanel3,'Title','Current panel')
    set(handles.popupmenu1, 'Visible','Off');
    ylabel('Current [A]');
end

Samples = length(ut1);          % pocet vzoriek casu / number of time samples
uL1=zeros(Samples,1);           % prealokacia
uL2=zeros(Samples,1);
uL3=zeros(Samples,1);
tmax = ut1(Samples,1);

% nacitanie hodnot z GUI
set(handles.time,'Min',0,'Max',tmax)                        % nastavenie min max slideru 
set(handles.resolution,'Min',0.01,'Max',tmax)               % nastavenie min max hodnoty slideru RESOLUTION
y_min1=str2double(get(handles.y_min,'String'));             % min hodnota y
y_max1=str2double(get(handles.y_max,'String'));             % max hodnota y
plim1=str2double(get(handles.plim,'String'));               % rozsah fazoroveho diagramu
z_c = get(handles.time,'Value');        % ziadany cas / desired time
res = get(handles.resolution,'Value');  % hodnota na ovladanie rozlisenia

% nastavenie pop up menu
contents = get(handles.popupmenu1,'Value');
switch contents
    case 1
        AA=sqrt(3);     % fazova hodnota - Line to ground voltage
    case 2
        AA=1;           % zdruzena hodnota - Line to line voltage
    otherwise
end

TTTT = zeros(Samples,1);
for ii =1:1:Samples,    % hladanie pozadovanej hodnoty vo vektore / finding desired value of time in measured time vector ut1
    if ut1(ii,1)<=z_c
       TTTT(ii,1)=ut1(ii,1);
       p_z_c = length(TTTT);    % desired measured time value
    end
       clear TTTT
end
 
ii=p_z_c;
    uL1(ii,1)=AA*Um1(ii,1)*exp(1i*omegatL1(ii,1));
    uL2(ii,1)=AA*Um1(ii,2)*exp(1i*omegatL2(ii,1));
    uL3(ii,1)=AA*Um1(ii,3)*exp(1i*omegatL3(ii,1));
    ufake = plim1 *exp(1i*0);
    % fazorovy diagram / phasor diagram
    axes(handles.axes1)
    fake = compass(real(ufake), imag(ufake));    % falosny fazor na riadenie rozsahu osi / fake invisible phasor - to change scale of phasor diagram
    set(fake, 'Visible','Off')
    hold on
    %%%
    A1 = compass(real(uL1(ii,1)), imag(uL1(ii,1)),'r');     % L1
    hold on
    set(A1, 'LineWidth',2);
    %%%
    A2 = compass(real(uL2(ii,1)), imag(uL2(ii,1)),'g');     % L2
    hold on
    set(A2, 'LineWidth',2);
    %%%
    A3 = compass(real(uL3(ii,1)), imag(uL3(ii,1)),'b');     % L3
    hold on
    set(A3, 'LineWidth',2);
    hold off
    axis('square');
    %xlabel('real part');
    %ylabel('imag part');
    A=([A1,A2,A3]);
    legend (A,'L1','L2','L3')
 
    axes(handles.axes2)  
    B1 = plot(ut1(:,1),AA*utL(:,1),'r','LineWidth',2);
    hold on
    if (get(handles.checkboxL1,'Value')==1)     % zviditelnenie a zneviditelnenie priebehu (jednej fazy) / L1 on/off
        set(A1, 'Visible','On')
        set(B1, 'Visible','On')
    else
        set(A1, 'Visible','Off') 
        set(B1, 'Visible','Off')
    end
    %%%
    B2 = plot(ut1(:,1),AA*utL(:,2),'g','LineWidth',2);
    hold on
    if (get(handles.checkboxL2,'Value')==1)     % L2 on/off
        set(A2, 'Visible','On')
        set(B2, 'Visible','On')
    else
        set(A2, 'Visible','Off') 
        set(B2, 'Visible','Off')
    end
    %%%
    B3 = plot(ut1(:,1),AA*utL(:,3),'b','LineWidth',2);
    hold on
    if (get(handles.checkboxL3,'Value')==1)     % L3 on/off
        set(A3, 'Visible','On')
        set(B3, 'Visible','On')
    else
        set(A3, 'Visible','Off') 
        set(B3, 'Visible','Off')
    end
    line([z_c z_c],[y_min1 y_max1],'color','k','LineWidth',2.5,'LineStyle','--', 'MarkerSize', 50)  %[0.5 0.5 0.5]  % tracker
    hold on
    hold off
    axis([z_c-res z_c+res y_min1 y_max1]);
    axis('square')
    xlabel('Time [s]');
    if (get(handles.radiobutton_U,'Value')==1)      % prepinanie nazvov osi v zavislosti na meranej velicine / change name of axes Voltage vs Current
        ylabel('Voltage [V]');
    else
        ylabel('Current [A]');
    end
    %title('signal');
    legend ('L1','L2','L3')
    grid on
    
    % aproximacia hodnoty priesecnika trackera a casovho priebehu /
    % approximating and setting the value of the intersection of the tracker and curve of time diagram (similar triangles)
    set(handles.UL1,'String',AA*((utL(ii+1,1)-utL(ii,1))*(z_c-ut1(ii,1)))/(ut1(ii+1,1)-ut1(ii,1))+utL(ii,1));   
    set(handles.UL2,'String',AA*((utL(ii+1,2)-utL(ii,2))*(z_c-ut1(ii,1)))/(ut1(ii+1,1)-ut1(ii,1))+utL(ii,2));
    set(handles.UL3,'String',AA*((utL(ii+1,3)-utL(ii,3))*(z_c-ut1(ii,1)))/(ut1(ii+1,1)-ut1(ii,1))+utL(ii,3));
    set(handles.time1,'String',z_c);
       
% --- Executes on button press in exit.
function exit_Callback(hObject, eventdata, handles)
% hObject    handle to exit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
close


% nastavenie minimalnej hodnoty y osi
function y_min_Callback(hObject, eventdata, handles)
% hObject    handle to y_min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of y_min as text
%        str2double(get(hObject,'String')) returns contents of y_min as a double
fazory(handles)

% --- Executes during object creation, after setting all properties.
function y_min_CreateFcn(hObject, eventdata, handles)
% hObject    handle to y_min (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% nastavenie maximalnej hodnoty y osi
function y_max_Callback(hObject, eventdata, handles)
% hObject    handle to y_max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of y_max as text
%        str2double(get(hObject,'String')) returns contents of y_max as a double
fazory(handles)

% --- Executes during object creation, after setting all properties.
function y_max_CreateFcn(hObject, eventdata, handles)
% hObject    handle to y_max (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% nastavenie hodnoty falosneho fazora
function plim_Callback(hObject, eventdata, handles)
% hObject    handle to plim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of plim as text
%        str2double(get(hObject,'String')) returns contents of plim as a double
fazory(handles)

% --- Executes during object creation, after setting all properties.
function plim_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% nastavenie casu - slider
% --- Executes on slider movement.
function time_Callback(hObject, eventdata, handles)
% hObject    handle to time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
val=get (handles.time1,'Value');
set(handles.time,'String',val);
fazory(handles)

% --- Executes during object creation, after setting all properties.
function time_CreateFcn(hObject, eventdata, handles)
% hObject    handle to time (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end



function UL1_Callback(hObject, eventdata, handles)
% hObject    handle to UL1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of UL1 as text
%        str2double(get(hObject,'String')) returns contents of UL1 as a double
fazory(handles)

% --- Executes during object creation, after setting all properties.
function UL1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to UL1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function UL2_Callback(hObject, eventdata, handles)
% hObject    handle to UL2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of UL2 as text
%        str2double(get(hObject,'String')) returns contents of UL2 as a double
fazory(handles)

% --- Executes during object creation, after setting all properties.
function UL2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to UL2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function UL3_Callback(hObject, eventdata, handles)
% hObject    handle to UL3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of UL3 as text
%        str2double(get(hObject,'String')) returns contents of UL3 as a double
fazory(handles)

% --- Executes during object creation, after setting all properties.
function UL3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to UL3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function time1_Callback(hObject, eventdata, handles)
% hObject    handle to time1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
val=get (handles.time1,'String');
set(handles.time,'Value',str2num(val));
% Hints: get(hObject,'String') returns contents of time1 as text
%        str2double(get(hObject,'String')) returns contents of time1 as a double
fazory(handles)
% --- Executes during object creation, after setting all properties.
function time1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to time1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% nastavenie line to line V line to ground
% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1
fazory(handles)

% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% nastavenie rozlisenie
% --- Executes on slider movement.
function resolution_Callback(hObject, eventdata, handles)
% hObject    handle to resolution (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider
fazory(handles)

% --- Executes during object creation, after setting all properties.
function resolution_CreateFcn(hObject, eventdata, handles)
% hObject    handle to resolution (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end

% vykreslenie figure(1) na ulozenie
% --- Executes on button press in save.
function save_Callback(hObject, eventdata, handles)
% hObject    handle to save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

clear ii

if (get(handles.radiobutton_U,'Value')==1)
    ut1 = evalin('base', 'ut_U.time');          % define values from workspace
    Um1 = evalin('base', 'Um.signals.values');
    omegatL1 = evalin('base', 'omegat_U.signals(1,1).values');
    omegatL2 = evalin('base', 'omegat_U.signals(1,2).values');
    omegatL3 = evalin('base', 'omegat_U.signals(1,3).values');
    utL = evalin('base', 'ut_U.signals.values');
    set(handles.text_L1,'String','UL1')         % set names of checkboxes in GUI in case of Voltage panel
    set(handles.text_L2,'String','UL2')
    set(handles.text_L3,'String','UL3')
    set(handles.popupmenu1, 'Visible','On');
    ylabel('Voltage [V]');
else
    ut1 = evalin('base', 'ut_I.time'); 
    Um1 = evalin('base', 'Im.signals.values');
    omegatL1 = evalin('base', 'omegat_I.signals(1,1).values');
    omegatL2 = evalin('base', 'omegat_I.signals(1,2).values');
    omegatL3 = evalin('base', 'omegat_I.signals(1,3).values');
    utL = evalin('base', 'ut_I.signals.values');
    set(handles.text_L1,'String','IL1')         % set names of checkboxes in GUI in case of Current panel
    set(handles.text_L2,'String','IL2')
    set(handles.text_L3,'String','IL3')
    set(handles.popupmenu1, 'Visible','Off');
    ylabel('Current [A]');
end

Samples = length(ut1);          % pocet vzoriek casu / number of time samples
uL1=zeros(Samples,1);           % prealokacia
uL2=zeros(Samples,1);
uL3=zeros(Samples,1);
tmax = ut1(Samples,1);

% nacitanie hodnot z GUI / values from GUI
set(handles.time,'Min',0,'Max',tmax)                        % nastavenie min max slideru 
set(handles.resolution,'Min',0.01,'Max',tmax)               % nastavenie min max hodnoty slideru RESOLUTION
y_min1=str2double(get(handles.y_min,'String'));             % min hodnota y
y_max1=str2double(get(handles.y_max,'String'));             % max hodnota y
plim1=str2double(get(handles.plim,'String'));               % rozsah fazoroveho diagramu
z_c = get(handles.time,'Value');        % ziadany cas
res = get(handles.resolution,'Value');  % hodnota na ovladanie rozlisenia

% nastavenie pop up menu
contents = get(handles.popupmenu1,'Value');
switch contents
    case 1
        AA=sqrt(3);    % fazova hodnota - Line to ground voltage
    case 2
        AA=1;  % zdruzena hodnota - Line to line voltage
    otherwise
end
                     
TTTT = zeros(Samples,1);
for ii =1:1:Samples,
    if ut1(ii,1)<=z_c
       TTTT(ii,1)=ut1(ii,1);
       p_z_c = length(TTTT); 
    end
    clear TTTT
end

figure(1);                          
ii=p_z_c;
    uL1(ii,1)=AA*Um1(ii,1)*exp(1i*omegatL1(ii,1));
    uL2(ii,1)=AA*Um1(ii,2)*exp(1i*omegatL2(ii,1));
    uL3(ii,1)=AA*Um1(ii,3)*exp(1i*omegatL3(ii,1));
    ufake = plim1 *exp(1i*0);
    % fazorovy diagram / phasor diagram
    subplot(1,2,1)
    fake = compass(real(ufake), imag(ufake));    % falosny fazor na riadenie rozsahu osi
    set(fake, 'Visible','Off')
    hold on                
    A1 = compass(real(uL1(ii,1)), imag(uL1(ii,1)),'r');
    set(A1, 'LineWidth',2);
    hold on
    A2 = compass(real(uL2(ii,1)), imag(uL2(ii,1)),'g');
    set(A2, 'LineWidth',2);
    hold on
    A3 = compass(real(uL3(ii,1)), imag(uL3(ii,1)),'b');
    hold on
    set(A3, 'LineWidth',2);
    hold off
    axis('square');
    A=([A1,A2,A3]);
    legend (A,'L1','L2','L3')
 
    % priebeh v case / time graph
    subplot(1,2,2) 
    B1 = plot(ut1(:,1),AA*utL(:,1),'r','LineWidth',2);
    hold on
    if (get(handles.checkboxL1,'Value')==1)         % L1 on/off
        set(A1, 'Visible','On')
        set(B1, 'Visible','On')
    else
        set(A1, 'Visible','Off') 
        set(B1, 'Visible','Off')
    end
    %%%
    B2 = plot(ut1(:,1),AA*utL(:,2),'g','LineWidth',2);
    hold on
    if (get(handles.checkboxL2,'Value')==1)         % L2 on/off
        set(A2, 'Visible','On')
        set(B2, 'Visible','On')
    else
        set(A2, 'Visible','Off') 
        set(B2, 'Visible','Off')
    end
    %%%
    B3 = plot(ut1(:,1),AA*utL(:,3),'b','LineWidth',2);
    hold on
    if (get(handles.checkboxL3,'Value')==1)         % L3 on/off
        set(A3, 'Visible','On')
        set(B3, 'Visible','On')
    else
        set(A3, 'Visible','Off') 
        set(B3, 'Visible','Off')
    end
    line([z_c z_c],[y_min1 y_max1],'color','k','LineWidth',2.5,'LineStyle','--', 'MarkerSize', 50)  %[0.5 0.5 0.5]
    hold on
    hold off
    axis([z_c-res z_c+res y_min1 y_max1]);
    axis('square')       
    xlabel('Time [s]');
    if (get(handles.radiobutton_U,'Value')==1)
        ylabel('Voltage [V]');
    else
        ylabel('Current [A]');
    end
    legend ('L1','L2','L3')
    grid on
% --------------------------------------------------------------------

% --- Executes on button press in checkboxL1.
function checkboxL1_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxL1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxL1
fazory(handles)

% --- Executes on button press in checkboxL2.
function checkboxL2_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxL2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxL2
fazory(handles)

% --- Executes on button press in checkboxL3.
function checkboxL3_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxL3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxL3
fazory(handles)

% --- Executes when selected object is changed in uipanel4.
function uipanel4_SelectionChangeFcn(hObject, eventdata, handles)
% hObject    handle to the selected object in uipanel4 
% eventdata  structure with the following fields (see UIBUTTONGROUP)
%	EventName: string 'SelectionChanged' (read only)
%	OldValue: handle of the previously selected object or empty if none was selected
%	NewValue: handle of the currently selected object
% handles    structure with handles and user data (see GUIDATA)
fazory(handles)
